loci.formats

## Class SubResolutionFormatReader

- java.lang.Object
- - loci.formats.FormatHandler
  - - loci.formats.FormatReader
    - - loci.formats.SubResolutionFormatReader

- All Implemented Interfaces:
    java.io.Closeable, java.lang.AutoCloseable, ICompressedTileReader, IFormatHandler, IFormatReader, IMetadataConfigurable, IPyramidHandler
  Direct Known Subclasses:
    DicomReader, ImarisHDFReader, MinimalTiffReader, ND2Reader, OMETiffReader

      public abstract class SubResolutionFormatReader
      extends FormatReader

  Abstract superclass of all biological file format readers that can handle image pyramids.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected CoreMetadataList` | `core` List of `CoreMetadata` objects for each series and resolution.

    - ### Fields inherited from class loci.formats.FormatReader

      `coreIndex, datasetDescription, domains, fillColor, filterMetadata, flattenedResolutions, group, hasCompanionFiles, in, indexedAsRGB, metadata, metadataStore, normalizeData, resolution, saveOriginalMetadata, series, suffixNecessary, suffixSufficient, THUMBNAIL_DIMENSION`

    - ### Fields inherited from class loci.formats.FormatHandler

      `COMPRESSION_SUFFIXES, currentId, format, LOGGER, metadataOptions, suffixes`

    - ### Fields inherited from interface loci.formats.IFormatReader

      `CAN_GROUP, CANNOT_GROUP, MUST_GROUP`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SubResolutionFormatReader(java.lang.String format, java.lang.String suffix)` Constructs a format reader with the given name and default suffix.
    `SubResolutionFormatReader(java.lang.String format, java.lang.String[] suffixes)` Constructs a format reader with the given name and default suffixes.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close(boolean fileOnly)` Closes the currently open file.
    `int` | `coreIndexToSeries(int index)` Returns the series corresponding to the specified core index.
    `protected void` | `flattenHashtables()` Call `FormatReader.updateMetadataLists(Hashtable)` on all metadata hashtables.
    `int` | `getCoreIndex()` Return the index into CoreMetadata of the current resolution/series.
    `java.util.List<CoreMetadata>` | `getCoreMetadataList()` Obtains the core metadata values for the current file.
    `protected CoreMetadata` | `getCurrentCore()` Get the CoreMetadata corresponding to the current series and resolution
    `int` | `getResolution()` Get the current resolution level.
    `int` | `getResolutionCount()` Return the number of resolutions for the current series.
    `int` | `getSeries()` Gets the currently active series.
    `int` | `getSeriesCount()` Gets the number of series in this file.
    `protected void` | `initFile(java.lang.String id)` Initializes the given file (parsing header information, etc.).
    `int` | `seriesToCoreIndex(int s)` Returns the first core index corresponding to the specified series.
    `void` | `setCoreIndex(int no)` Set the current resolution/series (ignores subresolutions).
    `void` | `setResolution(int no)` Set the resolution level.
    `void` | `setSeries(int no)` Activates the specified series.

    - ### Methods inherited from class loci.formats.FormatReader

      `addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMetaList, addMeta, addMetaList, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMetaList, close, fileGroupOption, get16BitLookupTable, get8BitLookupTable, getAcquisitionMode, getAdvancedSeriesUsedFiles, getAdvancedUsedFiles, getArcType, getAvailableOptions, getBinning, getBitsPerPixel, getCompression, getContrastMethod, getCorrection, getCurrentFile, getDatasetStructureDescription, getDetectorType, getDimensionOrder, getDimensionOrder, getDomains, getEffectiveSizeC, getExperimentType, getFilamentType, getFillColor, getFillRule, getFilterType, getFontFamily, getFontStyle, getGlobalMeta, getGlobalMetadata, getIlluminationType, getImageCount, getImmersion, getIndex, getIndex, getLaserMedium, getLaserType, getMarker, getMedium, getMetadataStore, getMetadataStoreRoot, getMetadataValue, getMicrobeamManipulationType, getMicroscopeType, getModuloC, getModuloT, getModuloZ, getNamingConvention, getOptimalTileHeight, getOptimalTileWidth, getPixelType, getPixelType, getPossibleDomains, getPulse, getRequiredDirectories, getRGBChannelCount, getRotationTransform, getSeriesMeta, getSeriesMetadata, getSeriesMetadataValue, getSeriesUsedFiles, getSeriesUsedFiles, getSizeC, getSizeT, getSizeX, getSizeY, getSizeZ, getThumbSizeX, getThumbSizeY, getTileColumns, getTileRows, getUnderlyingReaders, getUsedFiles, getUsedFiles, getZCTCoords, getZCTModuloCoords, hasCompanionFiles, hasFlattenedResolutions, isFalseColor, isGroupFiles, isIndexed, isInterleaved, isInterleaved, isLittleEndian, isMetadataComplete, isMetadataFiltered, isNormalized, isOrderCertain, isOriginalMetadataPopulated, isRGB, isSingleFile, isThisType, isThisType, isThisType, isThisType, isThumbnailSeries, isUsedFile, makeFilterMetadata, openBytes, openBytes, openBytes, openBytes, openPlane, openThumbBytes, readPlane, readPlane, readPlane, reopenFile, setFillColor, setFlattenedResolutions, setGroupFiles, setId, setMetadataFiltered, setMetadataStore, setNormalized, setOriginalMetadataPopulated, updateMetadataLists`

    - ### Methods inherited from class loci.formats.FormatHandler

      `checkSuffix, checkSuffix, getFormat, getMetadataOptions, getNativeDataType, getSuffixes, getSupportedMetadataLevels, setMetadataOptions`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface loci.formats.IFormatHandler

      `getFormat, getNativeDataType, getSuffixes`

    - ### Methods inherited from interface loci.formats.IMetadataConfigurable

      `getMetadataOptions, getSupportedMetadataLevels, setMetadataOptions`

    - ### Methods inherited from interface loci.formats.ICompressedTileReader

      `getTileCodec, getTileCodecOptions, openCompressedBytes, openCompressedBytes`

- - ### Field Detail

    - #### core

          protected CoreMetadataList core

      List of `CoreMetadata` objects for each series and resolution.

  - ### Constructor Detail

    - #### SubResolutionFormatReader

          public SubResolutionFormatReader(java.lang.String format,
                                           java.lang.String suffix)

      Constructs a format reader with the given name and default suffix.

    - #### SubResolutionFormatReader

          public SubResolutionFormatReader(java.lang.String format,
                                           java.lang.String[] suffixes)

      Constructs a format reader with the given name and default suffixes.

  - ### Method Detail

    - #### initFile

          protected void initFile(java.lang.String id)
                           throws FormatException,
                                  java.io.IOException

      Initializes the given file (parsing header information, etc.). Most subclasses should override this method to perform initialization operations such as parsing metadata.
      Overrides:
        `initFile` in class `FormatReader`
      Throws:
        `FormatException` - if a parsing error occurs processing the file.
        `java.io.IOException` - if an I/O error occurs processing the file

    - #### flattenHashtables

          protected void flattenHashtables()

      Call `FormatReader.updateMetadataLists(Hashtable)` on all metadata hashtables.
      Overrides:
        `flattenHashtables` in class `FormatReader`

    - #### close

          public void close(boolean fileOnly)
                     throws java.io.IOException

      Description copied from interface: `IFormatReader`
      Closes the currently open file. If the flag is set, this is all that happens; if unset, it is equivalent to calling `Closeable.close()`.
      Specified by:
        `close` in interface `IFormatReader`
      Overrides:
        `close` in class `FormatReader`
      Throws:
        `java.io.IOException`

    - #### getSeriesCount

          public int getSeriesCount()

      Description copied from interface: `IFormatReader`
      Gets the number of series in this file.
      Specified by:
        `getSeriesCount` in interface `IFormatReader`
      Overrides:
        `getSeriesCount` in class `FormatReader`
      See Also:
        `Note that the value can change depending upon whether resolutions are flattened, and so reader implementations should use the series and resolutions fields internally.`

    - #### setSeries

          public void setSeries(int no)

      Description copied from interface: `IFormatReader`
      Activates the specified series. This also resets the resolution to 0.
      Specified by:
        `setSeries` in interface `IFormatReader`
      Overrides:
        `setSeries` in class `FormatReader`
      See Also:
        `Note that the value can change depending upon whether resolutions are flattened, and so reader implementations should use the series and resolutions fields internally.`

    - #### getSeries

          public int getSeries()

      Description copied from interface: `IFormatReader`
      Gets the currently active series.
      Specified by:
        `getSeries` in interface `IFormatReader`
      Overrides:
        `getSeries` in class `FormatReader`

    - #### getCoreMetadataList

          public java.util.List<CoreMetadata> getCoreMetadataList()

      Description copied from interface: `IFormatReader`
      Obtains the core metadata values for the current file.
      Specified by:
        `getCoreMetadataList` in interface `IFormatReader`
      Overrides:
        `getCoreMetadataList` in class `FormatReader`

    - #### seriesToCoreIndex

          public int seriesToCoreIndex(int s)

      Description copied from interface: `IFormatReader`
      Returns the first core index corresponding to the specified series.
      Specified by:
        `seriesToCoreIndex` in interface `IFormatReader`
      Overrides:
        `seriesToCoreIndex` in class `FormatReader`

    - #### coreIndexToSeries

          public int coreIndexToSeries(int index)

      Description copied from interface: `IFormatReader`
      Returns the series corresponding to the specified core index.
      Specified by:
        `coreIndexToSeries` in interface `IFormatReader`
      Overrides:
        `coreIndexToSeries` in class `FormatReader`

    - #### getResolutionCount

          public int getResolutionCount()

      Description copied from interface: `IPyramidHandler`
      Return the number of resolutions for the current series. Resolutions are stored in descending order, so the largest resolution is first and the smallest resolution is last.
      Specified by:
        `getResolutionCount` in interface `IPyramidHandler`
      Overrides:
        `getResolutionCount` in class `FormatReader`

    - #### setResolution

          public void setResolution(int no)

      Description copied from interface: `IPyramidHandler`
      Set the resolution level.
      Specified by:
        `setResolution` in interface `IPyramidHandler`
      Overrides:
        `setResolution` in class `FormatReader`
      See Also:
        `IPyramidHandler.getResolutionCount()`

    - #### getResolution

          public int getResolution()

      Description copied from interface: `IPyramidHandler`
      Get the current resolution level.
      Specified by:
        `getResolution` in interface `IPyramidHandler`
      Overrides:
        `getResolution` in class `FormatReader`
      See Also:
        `IPyramidHandler.getResolutionCount()`

    - #### getCoreIndex

          public int getCoreIndex()

      Description copied from interface: `IFormatReader`
      Return the index into CoreMetadata of the current resolution/series.
      Specified by:
        `getCoreIndex` in interface `IFormatReader`
      Overrides:
        `getCoreIndex` in class `FormatReader`

    - #### setCoreIndex

          public void setCoreIndex(int no)

      Description copied from interface: `IFormatReader`
      Set the current resolution/series (ignores subresolutions). Equivalent to setSeries, but with flattened resolutions always set to false.
      Specified by:
        `setCoreIndex` in interface `IFormatReader`
      Overrides:
        `setCoreIndex` in class `FormatReader`

    - #### getCurrentCore

          protected CoreMetadata getCurrentCore()

      Get the CoreMetadata corresponding to the current series and resolution
      Overrides:
        `getCurrentCore` in class `FormatReader`
      Returns:
        the CoreMetadata

Copyright © 2026 Open Microscopy Environment